exercise_05_27: exercise_05_27.o | .gitignore
	g++ $^ -o $@ 

exercise_05_27.ii: exercise_05_27.cpp
	g++ -E $^ -o $@

exercise_05_27.s: exercise_05_27.ii
	g++ -S $^ -o $@

exercise_05_27.o: exercise_05_27.s
	g++ -c $^ -o $@

.gitignore:
	echo "exercise_05_27" > $@

clean:
	rm -rf *.ii *.s *.o *.out exercise_05_27 .gitignore debug

test: exercise_05_27 
	./exercise_05_27 > test.out
	diff test.out test.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

.PRECIOUS: exercise_05_27.ii exercise_05_27.s
.SECONDARY: exercise_05_27.ii exercise_05_27.s

dbg: debug/exercise_05_27 

debug/exercise_05_27: debug/exercise_05_27.o | .gitignore
	g++ -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_05_27.o: debug/exercise_05_27.s
	g++ -c -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_05_27.s: debug/exercise_05_27.ii
	g++ -S -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_05_27.ii: exercise_05_27.cpp | debug
	g++ -E -Wall -Wextra -Werror -g3 $^ -o $@

debug:
	mkdir -p debug

